
// Include the header files
#include <Blackfin_definitions.h>
#include <functions.h>
#include <SDDefinitions.h>
extern int ResponseBuffer [9];
extern volatile int DataResponseFlag;


char source[515];
char dest[515];
int t;

//#define EraseData //Uncomment this to Erase data

void main()
{
	int i;
	PLLSetupBF();
	PinMuxing();
	SetUpInterruptsBF();
	
	// Initialize SD Card 
	// Sends CMD0 and CMD1 to the SD Card
	SDInit();	
		
	SDSetBlockLength(512);
	
	// Initialize source data 
	// Write block length is fixed to 512
	// First word is data token and last two words are CRC bytes
	for(i=0;i<515;i++)
	{
		// First value should be 0xFE - DATA Token
		if (i==0)
		{
			source[i] = 0xFE;
		}
		// Last two values should be 0xFF
		else if ((i==513)||(i==514))
		{
			source[i] = 0xFF;
		}
		else
			source[i] = i; // User specific data
	}
	
	
	SDWriteData (0x0,source);
	printf("******Write Data Done******\n");
	SDReadData(0x0,dest);
	printf("******Read Data Done******\n");
	
	//Data Check
	for(i=0;i<512;i++)
	{
		if(dest[i] != source[i+1])
		{
			printf("Error data at location %d\n", i);
		}
	}
	printf("******Data Check Done******\n");
	
	#ifdef EraseData
	SDEraseGroup(0x0,1);
	printf("******Erase Data Done******\n");
	SDReadData(0x0,dest);
	printf("******Read Data Done******\n");
	#endif
}
